        PROGRAM ZENER_CAPI
C
C       ===================================================
C       Purpose: This program computes growth parameter for
C       shperical particles with a capillarity correciton 
C       term
C       ===================================================
C
C       Copyright Pedro Rivera and H. K. D. H. Bhadeshia,
C       University of Cambridge, 1999
C

       IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER(I,J)
       PI = 3.141592654             
       OU1 = 1
       OPEN(UNIT = OU1,FILE='res1.d')
       R = 1.01d0

       DO 5 I=1,10000
       O=10**(-4+I*0.0004)      
       GP=0.5
       GP1=0.0D0
       GOTO 15
10     X=GP/2.0D0
       X1=GP/2.0D0
15     CALL ERROR(X,ER)
       CALL ERROR(X1,ER1)
       F=((GP**2.0D0)/2.0D0)*(1-SQRT(PI)*0.5D0*GP*DEXP
&        (X**2)*(1.0D0-ER))
       F1=((GP1**2.0D0)/2.0D0)*(1-SQRT(PI)*0.5D0*GP*DEXP
&        (X1**2)*(1.0D0-ER1))
       P1=O-F1/(1.0D0+((1.0D0/R)*(F1-1.0D0)))
       P=O-F/(1.0D0+((1.0D0/R)*(F-1.0D0)))
       IF (((P.GT.0.0D0).AND.(P1.GT.0.0D0)).OR.
&        ((P.LT.0.0D0).AND.(P1.LT.0.0D0))) THEN
         GP1=GP
         A=2.0D0*GP
         IF (A.LE.10.0D0) THEN
          GP=2*GP
         ELSE
          GP=11.0D0
         ENDIF
         GOTO 10
       ELSE
         GP=GP1+0.5D0*(GP-GP1)
         IF (ABS((GP-GP1)/GP).LT.1.0D-7) THEN
           GOTO 20
         ELSE
           GOTO 10
         ENDIF
       ENDIF
       P1=O-F1
       P=O-F
20     WRITE(OU1,200) O, GP
c       write(*,200)0,GP,X,X1
5      CONTINUE
200	FORMAT(1X,4D15.5)
        END


        SUBROUTINE ERROR(X,ERR)
C
C       =========================================
C       Purpose: Compute error function erf(x)
C       Input:   x   --- Argument of erf(x)
C       Output:  ERR --- erf(x)
C       =========================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        EPS=1.0D-15
        PI=3.141592653589793D0
        X2=X*X
        IF (DABS(X).LT.3.5D0) THEN
           ER=1.0D0
           R=1.0D0
           DO 10 K=1,50
              R=R*X2/(K+0.5D0)
              ER=ER+R
              IF (DABS(R).LE.DABS(ER)*EPS) GO TO 15
10         CONTINUE
15         C0=2.0D0/DSQRT(PI)*X*DEXP(-X2)
           ERR=C0*ER
        ELSE
           ER=1.0D0
           R=1.0D0
           DO 20 K=1,12
              R=-R*(K-0.5D0)/X2
20            ER=ER+R
           C0=DEXP(-X2)/(DABS(X)*DSQRT(PI))
           ERR=1.0D0-C0*ER
           IF (X.LT.0.0) ERR=-ERR
        ENDIF
        RETURN
        END
